#! /bin/bash
#
# install script fuer maus-sk am Server
# 24.10.2019
# mit linuxmuster.net 7 Unterstuetzung
#
##################################################################

lmn7=$(dpkg -s linuxmuster-base7 2>&1 | grep Status)

if [[ $lmn7 =~ 'install ok' ]]
then
   echo "###################################"
   echo "# Install linuxmuster.net 7       #"
   echo "###################################"
   admin="global-admin"
   pfad="/srv/samba/schools/default-school/program/maus_sk/"
   pfad2="/srv/samba/schools/default-school/program/mausdienst/"
   etcpfad="/etc/linuxmuster/maus/"
   sbinpfad="/usr/sbin/"
   initpfad="/etc/init.d/"
   wwwpfad="/var/www/"
   common_bat="/var/lib/samba/sysvol/lmn.lan/scripts/default-school/lmn/windows/logon.bat"
   #mausdienst_zeile="REM if exist \\\\server\default-school\program\mausdienst\mausdienst.exe start \\\\server\default-school\program\mausdienst\mausdienst.exe"
   mausdienst_zeile="REM if exist K:\mausdienst\mausdienst.exe start K:\mausdienst\mausdienst.exe"
   desktopclient="maus_sk.desktop7"
   installclient="install-u-c.7"

else
   echo "###################################"
   echo "# Install linuxmuster.net 6       #"
   echo "###################################"
   admin="pgmadmin"
   pfad="/home/samba/progs/maus_sk/"
   pfad2="/home/samba/progs/mausdienst/"
   etcpfad="/etc/linuxmuster/maus/"
   sbinpfad="/usr/sbin/"
   initpfad="/etc/init.d/"
   wwwpfad="/var/www/"
   common_bat="/home/samba/netlogon/common.bat"
   mausdienst_zeile="REM if exist \\\\%SERVER%\pgm\mausdienst\mausdienst.exe start \\\\%SERVER%\pgm\mausdienst\mausdienst.exe"
   pfad_old="/home/samba/progs/minisk"
   pfad_old2="/home/samba/progs/maus2"
   desktopclient="maus_sk.desktop6"
   installclient="install-u-c.6"

fi

##################################################################

if [ "$(id -u)" != "0" ]; then
   echo "###################################"
   echo "# This script must be run as root #"
   echo "###################################"
   exit 1
fi

apt-get -y install openssl apg x11vnc

if ! [ -e "$pfad" ]; then
   mkdir -p $pfad
   if ! [[ $lmn7 =~ 'install ok' ]]; then
     if [ -e "$pfad_old"/mini_sk.cfg ]; then
        cp "$pfad_old"/mini_sk.cfg "$pfad"maus_sk.cfg
     fi
     if [ -e "$pfad_old2"/maus.cfg ]; then
        cp "$pfad_old2"/maus.cfg "$pfad"maus_offline.cfg
     fi
     if [ -e "$pfad_old" ]; then
        mv "$pfad_old" "$pfad_old"_old
     fi
     if [ -e "$pfad_old2" ]; then
        mv "$pfad_old2" "$pfad_old2"_old
     fi
   fi
fi

mkdir -p $pfad2
mkdir -p $etcpfad
mkdir -p $wwwpfad

if [[ $lmn7 =~ 'install ok' ]]; then
   echo "lmn7: usermod bei lmn7 nicht notwendig"
else
   echo "lmn6: Die Gruppenzugehoerigkeit vom pgmadmin wird konfiguriert ..."
   smbldap-usermod -G teachers pgmadmin
   sophomorix-passwd -u pgmadmin --shell /bin/bash
fi

if [ -e "$pfad2"md.pass ] && ! [ -s "$pfad2"md.pass ]; then
    rm "$pfad2"md.pass
    echo "Loesche leere Passwort-Datei md.pass."
fi

if [ -e "$pfad2"md.pass ]; then
  mv -f "$pfad2"md.pass "$etcpfad"md.pass
fi

if [ -e "$pfad2"md.pass.neu ]; then
  rm -f "$pfad2"md.pass.neu
fi

if [ -e "$etcpfad"md.pass ]; then
   echo "#####################################################################"
   echo "# ACHTUNG!                                                          #"
   echo "# Das md-Passwort md.pass existiert schon, es wird beibehalten.     #"
   echo "# Ein neues Passwort liegt nun unter md.pass.neu. und md.md5.neu    #"
   echo "# Ggf. das bisherige Passwort und md5-Datei umbenennen und ersetzen.#"
   echo "#####################################################################"
   md5sum "$etcpfad"md.pass | awk -F" " '{print $1}' > "$pfad2"md.md5
   apg -n 1 -m 16 -M c | tr -d "\n" > "$etcpfad"md.pass.neu
   md5sum "$etcpfad"md.pass.neu | awk -F" " '{print $1}' > "$pfad2"md.md5.neu
else
   echo "md-Passwort wird erzeugt ..."
   apg -n 1 -m 16 -M c | tr -d "\n" > "$etcpfad"md.pass
   md5sum "$etcpfad"md.pass | awk -F" " '{print $1}' > "$pfad2"md.md5
fi

if [ -e "$pfad2"md.key ]; then
  rm -f "$pfad2"md.key
fi

# openssl genrsa -out "$etcpfad"md.key 2048
# openssl req -x509 -new -nodes -subj "/C=DE/ST=BW/L=Schule/O=Mausdienst/CN=Mausdienst" -extensions v3_ca -key "$etcpfad"md.key -days 3650 -out "$etcpfad"md.cert -sha512
# cp -f "$etcpfad"md.cert "$pfad2"md.cert

echo "Dateien werden am Server kopiert ..."

if [ -e "$pfad"maus_sk.cfg ]; then
   echo "#############################################################################"
   echo "# ACHTUNG!                                                                  #"
   echo "# Die Konfigurationsdatei maus_sk.cfg existiert schon, sie wird beibehalten.#"
   echo "# Eine neue Konfigurationsdatei liegt nun unter maus_sk.cfg.neu.            #"
   echo "# Ggf. die bisherige Konfigurationsdatei entsprechend anpassen.             #"
   echo "#############################################################################"
   cp maus_sk.cfg "$pfad"maus_sk.cfg.neu
else
   cp maus_sk.cfg $pfad

   myip=$(hostname -i)
   echo "Setze Server-IP auf "$myip
   sed -i "s/ServerIP=.*/ServerIP=$myip/g" "$pfad/maus_sk.cfg"
fi

cp maus_sk $pfad
cp maus_sk.exe $pfad
cp maus_sk.ico $pfad
cp $desktopclient "$pfad"maus_sk.desktop
cp $installclient "$pfad"install-ubuntu-client.sh
cp openssl.64/libeay32.dll $pfad
cp openssl.64/ssleay32.dll $pfad
cp version $pfad

cp mausdaemon $pfad2
cp mausdaemon.sh $pfad2
cp internetdaemon $pfad2
cp internetdaemon.sh $pfad2
cp mausdaemon.cfg $pfad2
cp sperren.sh $pfad2
cp freigeben.sh $pfad2
cp nachricht.sh $pfad2
cp 50xhost-root.sh $pfad2
cp befehl.sh $pfad2
cp url.sh $pfad2
cp closed.xbm $pfad2
cp xhost-root.sh $pfad2

cp mausdienst.exe $pfad2
cp mausdienst.cfg $pfad2
cp openssl.32/libeay32.dll $pfad2
cp openssl.32/ssleay32.dll $pfad2
cp winKeyLockHook.dll $pfad2

if [ -e "$common_bat" ]; then
  if ! grep -q 'mausdienst.exe' "$common_bat" ; then
    echo "Login-Script common.bat wird für Windows angepasst ..."
    echo "" >> $common_bat
    echo "REM ### Mausdienst beim login starten ###" >> $common_bat
    echo "" >> $common_bat
    echo $mausdienst_zeile >> $common_bat
  fi
fi

if [ -e "$pfad2"x11vnc.text ]; then
  mv -f "$pfad2"x11vnc.text "$etcpfad"x11vnc.text
fi

if [ -e "$pfad2"x11vnc.pass ]; then
  mv -f "$pfad2"x11vnc.pass "$etcpfad"x11vnc.pass
fi


touch "$etcpfad"x11vnc.text
if [ -e "$pfad"maus_offline.cfg ]; then
   echo "########################################################################"
   echo "# ACHTUNG!                                                             #"
   echo "# Die Konfigurationsdatei maus_offline.cfg existiert schon,            #"
   echo "# sie wird beibehalten.                                                #"
   echo "# Eine neue Konfigurationsdatei liegt nun unter maus_offline.cfg.neu.  #"
   echo "# Ggf. die bisherige Konfigurationsdatei entsprechend anpassen.        #"
   echo "########################################################################"
   cp maus_offline.cfg "$pfad"maus_offline.cfg.neu
else
   cp maus_offline.cfg $pfad
fi

cp wol.exe $pfad

cp maussk.html $wwwpfad
cp *.apk $wwwpfad

echo "Zugriffsrechte werden gesetzt ..."
chown -R $admin:teachers $pfad $pfad2
chown -R root:root $etcpfad
chmod -R 750 $etcpfad

chmod -R 750 $pfad
chmod 755 $pfad
chmod -R 755 $pfad2
chmod 640 "$pfad"maus_sk.cfg "$pfad"maus_sk.ico "$pfad"maus_offline.cfg
chmod 644 "$pfad2"mausdienst.cfg "$pfad2"mausdaemon.cfg "$pfad2"md.md5 
# chmod 644 "$pfad2"md.cert

if [ -e "$pfad2"md.md5.neu ]; then
  chmod 640 "$pfad2"md.md5.neu
fi
if [ -e "$pfad"maus_sk.cfg.neu ]; then
  chmod 640 "$pfad"maus_sk.cfg.neu
fi
if [ -e "$pfad"maus_offline.cfg.neu ]; then
  chmod 640 "$pfad"maus_offline.cfg.neu
fi

if [ -e "$etcpfad"schukodaemon.cfg ]; then
   echo "############################################################################"
   echo "# ACHTUNG!                                                                 #"
   echo "# Die Konfigurationsdatei schukodaemon.cfg ex. schon, sie wird beibehalten.#"
   echo "# Eine neue Konfigurationsdatei liegt nun unter schukodaemon.cfg.neu.      #"
   echo "# Ggf. die bisherige Konfigurationsdatei entsprechend anpassen.            #"
   echo "############################################################################"
   cp schukodaemon.cfg "$etcpfad"schukodaemon.cfg.neu
   chmod 640 "$etcpfad"schukodaemon.cfg.neu
else
   cp schukodaemon.cfg $etcpfad
   chmod 640 "$etcpfad"schukodaemon.cfg
fi

chmod 644 "$wwwpfad"maussk.html "$wwwpfad"*.apk

# echo "Keypaar für die eine optionale ssl-Kommunikation mit server wird erstellt ..."
# openssl genrsa -out "$etcpfad"sk.key 2048
# openssl req -x509 -new -nodes -subj "/C=DE/ST=BW/L=Schule/O=schukodaemon/CN=schukodaemon" -extensions v3_ca -key "$etcpfad"sk.key -days 3650 -out "$etcpfad"sk.cert -sha512

echo "Prozesse schukodaemon stop ..."
killall -e -9 schukodaemon
sleep 2

if [[ $lmn7 =~ 'install ok' ]]; then
   echo "Firewall -> keine Aenderung bei lmn7 notwendig"
else
   echo "Firewall bei lmn6 wird konfiguriert ..."
   sed -i '/[^0-9]9731/ !s/^tcp .*/&,9731/' /etc/linuxmuster/allowed_ports
   sed -i '/[^0-9]9732/ !s/^tcp .*/&,9732/' /etc/linuxmuster/allowed_ports
   restart-fw --int
fi


cp schukodaemon $sbinpfad
cp schukodaemon.sh $initpfad

chown root:root "$sbinpfad"schukodaemon "$initpfad"schukodaemon.sh
chmod 755 "$sbinpfad"schukodaemon "$initpfad"schukodaemon.sh

echo "Boot-Script wird aktiviert ..."

/usr/sbin/update-rc.d schukodaemon.sh defaults

"$initpfad"schukodaemon.sh start

echo "### Installation maus_sk und schukodaemon beendet ###"

exit 0
